/* workspace.h
   Stephen Sorkin
   This file defines the Workspace class.
   It keeps track of all the necessary information for maintaining a 2D 
   workspace with obstacles and one point robot.
   */

#ifndef _workspace_h
#define _workspace_h

#include <iostream.h>
#include "distance/dist.h"

class Obstacle;

struct RobotState {
  double dist;
  bool inBound;
  Obstacle *obst;
};

class Workspace {
public:
  Workspace(istream& workData);

  const RobotState testRobotState(Frame2 *robotFrame) const;

  const Point2& getPointRef(int ref) const {return points[ref];}

private:
  Frame2 obstFrame;

  int numPts;
  Point2 *points;
  int numObsts;
  Obstacle *obstacles;
  Sobj2 *obstRep;
  Sobj2 *robotRep;

  void readWorkData(istream& workData);
  void buildObstRep();
};

#endif


